var coqdocjs = coqdocjs || {};

coqdocjs.repl = {
    "fun": "λ",
    "forall": "∀",
    "exists": "∃",
    "~": "¬",
    "/\\": "∧",
    "\\/": "∨",
    ">->": "↣",
    "<->": "↔",
    "->": "→",
    "<-": "←",
    "=>": "⇒",
    "<>": "≠",
    "<=": "≤",
    ">=": "≥",
    "el": "∈",
    "nel": "∉",
    "<<=": "⊆",
    "<<": "⊂",
    "|-": "⊢",
    "++": "⧺",
    "===": "≡",
    "=/=": "≢",
    "=~=": "≅",
    "==>": "⟹",
    "lhd": "⊲",
    "rhd": "⊳",
    "nat": "ℕ",
    "alpha": "α",
    "beta": "β",
    "gamma": "γ",
    "delta": "δ",
    "epsilon": "ε",
    "eta": "η",
    "iota": "ι",
    "kappa": "κ",
    "lambda": "λ",
    "mu": "μ",
    "nu": "ν",
    "omega": "ω",
    "phi": "ϕ",
    "pi": "π",
    "psi": "ψ",
    "rho": "ρ",
    "sigma": "σ",
    "tau": "τ",
    "theta": "θ",
    "xi": "ξ",
    "zeta": "ζ",
    "Delta": "Δ",
    "Gamma": "Γ",
    "Pi": "Π",
    "Sigma": "Σ",
    "Omega": "Ω",
    "Xi": "Ξ",

// Language relations
    "<$="  : "⊆",
    "=$="  : "≡",
    "\\$/" : "∪",
    "/$\\" : "∩",
    "^$~"  :  "<sup>C</sup>",
    ")^$~" : ")<sup>C</sup>",
    "{}"   : "∅",
    "^0$0" : "<sup>ω</sup>",

// String and Language operations
    "++": "⧺",
    "+++": "⧻",
    "o": "·",
    "to_omega": "<sup>ω</sup>",
    "^00"     :  "<sup>ω</sup>",
    ")^00"    :  ")<sup>ω</sup>",

// Nicer function names
    "infinite_filter"    : "filter<sub>ω</sub>",
    "concat_inf"         : "concat<sub>ω</sub>",
    "concat_inf_indices" : "concatI<sub>ω</sub>",
    "L_B"  : "L<sub>B</sub>",
    "L_B(" : "L<sub>B</sub>(",
    "L_S"  : "L<sub>S</sub>",
    "L_S(" : "L<sub>S</sub>(",


// Complement notations
    "===>" : "⟹",
    "=!=>" : "⟹<sub>A</sub>",
    "{[" : "⟦",
    "]}" : "⟧",

// Sets
    "elS" : "∈",
    "=~=" : "≡",
// MSO
    "<0" : "<",
    "<<=0" : "⊆",
    "/\\0" : "∧",
    "~0"  : "¬",
    "ex0" : "∃",

    "<2"  : "<",
    "<=2"  : "≤",
    "el2" : "∈",
    "<<=2" : "⊆",
    "/\\2" : "∧",
    "\\/2" : "∨",
    "==>2" : "→",
    "~2"  : "¬",
    "(~2"  : "(¬",
    "~2("  : "¬(",
    "ex1"  : "∃",
    "ex2"  : "∃",
    "all1"  : "∀",
    "all2"  : "∀",
    "OR"  : "<element style=\"font-size: 200%; position:relative; top: 3px;\">∨</element>",
    "AND"  : "<element style=\"font-size: 200%; position:relative; top: 3px;\">∧</element>",

    "|=" : "⊨",
    "|==" : "⊨",

};

coqdocjs.subscr = {
  "0" : "₀",
  "1" : "₁",
  "2" : "₂",
  "3" : "₃",
  "4" : "₄",
  "5" : "₅",
  "6" : "₆",
  "7" : "₇",
  "8" : "₈",
  "9" : "₉",
};

coqdocjs.replInText = ["o", "^00", "~~#", "~~", "===>", "=!=>",
   "==>","<=>", "=>", "<=", "<->", "->", "<-", ":="];
// Use this for replInText in html  of 8.7

//Object.keys(coqdocjs.repl).filter(
//  a =>  !(/[a-z].*/i.test(a))  //only replace tokens which do not atsrt with a letter
//).sort(function(a,b) {  // Sort be length, start with the longest
//   if (a.length < b.length) return  1; 
//   if (a.length > b.length) return -1; 
//   return 0;
//});
//
